var System = java.lang.System,
    ApplicationFacade = com.cattura.agents.configuration_module.controller.facade.ApplicationFacade,
    DefaultPaths = com.cattura.agents.configuration_module.model.properties.DefaultPaths,
    LOGGER = plugin.info().logger,
    facade = require("facade"),
    HTTP = require("http");
    
importPackage(java.io);
importPackage(java.net);
importPackage(java.util.logging);

var LOGGER = plugin.info().logger;

var URLS = plugin.info().configuration.get("urls");
URLS = (URLS === null ? [] : Objects.fromCollection(URLS));

var settings = facade.retrieveProxy("SettingsProxy");
var statusProxy = facade.retrieveProxy("EnvironmentProxy");

plugin.onException(function(exception) {
    var networkWatcher = statusProxy.getNetworkStatusWatcher();
    var subject = "Cattura Hardware Agent Exception Report: " + exception.getClass().getName() + " at " + new java.util.Date().toString() + " on " + settings.get("unit-name");
    var out = new StringWriter();
    exception.printStackTrace(new PrintWriter(out));
    
    for (var i = 0; i < URLS.length; i++)
    {
        HTTP.post(URLS[i], {
            unitName: settings.get("unit-name"),
            exceptionType: exception.getClass().getName(),
            exceptionStackTrace: out.toString(),
            timestamp: java.lang.System.currentTimeMillis(),
            localIP: networkWatcher.getLocalIP(),
            globalIP: networkWatcher.getGlobalIP()
        });
    }    
});